//@ sourceURL=user_manage.js
$(function () {
    $("input").each(function () {
        this.onkeydown = function (e) { // 监听键盘事件
            let theEvent = window.event || e;
            let code = theEvent.keyCode || theEvent.which;
            if (code == 13) {//回车事件
                $("#btn_search").click(); //触发搜索按钮点击事件
            }
        }
    });
    //新增按钮点击事件
    $("#btn_add").click(function (t) {
        $("#editModal").modal();
        $("#classTitle").text("新增");
        clearInput();
    });
    //角色保存按钮点击事件
    $("#btn_save").click(function (t) {
        var validatorResult = validator.checkAll($("#editUserForm"));
        if (validatorResult) {
            saveUser();
        }
    });
    //初始化表格数据
    getAllUser();
    getAllRole();
});


//初始化角色下拉
function getAllRole() {
    $.ajax({
        type: "POST",
        url: '/thmz/getAllRole',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view';
                return;
            }
            if (res.code == 0) {
                //初始化角色下拉
                var arr = res.data;
                if (arr != null && arr.length > 0) {
                    var html = "";
                    for (var i = 0; i < arr.length; i++) {
                        html += "<option value='" + arr[i].id + "'>" + arr[i].roleName + "</option>";
                    }
                    $('#roleName').html(html);
                    $('#roleName').selectpicker('refresh');
                } else {
                    errorMesage(res);
                }
            }
        }
    });
}


/**
 * 保存用户数据
 */
function saveUser() {
    var id = $("#id").val();
    var roles = $("#roleName").val();
    var roleIds = null;
    if (roles.length > 0) {
        for (var i = 0; i < roles.length; i++) {
            if (roleIds == null) {
                roleIds = roles[i];
            } else {
                roleIds += "," + roles[i];
            }
        }
    }
    var data = null;
    //修改用户
    if (id != null) {
        data = JSON.stringify({
            user: {
                id: id
            },
            roleIds: roleIds
        });
    } else {
        //新增用户
    }
    console.log(data);
    $.ajax({
        type: "POST",
        url: '/thmz/saveUserRoleRelation',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        data: data,
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $("#editModal").modal("hide");
                clearInput();
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}


/**
 * 清空输入框
 */
function clearInput() {
    $("#id").val(null);
    $("#roleName").attr("lang", '0');
    $("#roleName").selectpicker('refresh');
    $('#userCode').val(null);
    $('#userName').val(null);
}


/**
 * 查询角色列表
 */
function getAllUser() {
    $('#tb_table').bootstrapTable("destroy");
    $('#tb_table').bootstrapTable({
        url: '/thmz/getUserPage',         //请求后台的URL（*）
        method: 'post',                      //请求方式（*）
        async: false,
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: true,                     //是否启用排序
        sortOrder: "asc",                   //排序方式
        queryParams: queryParams,           //传递参数（*）
        sidePagination: "server",           //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1,                       //初始化加载第一页，默认第一页
        pageSize: 10,                       //每页的记录行数（*）
        pageList: [10, 25, 50, 100],        //可供选择的每页的行数（*）
        search: false,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
        showColumns: false,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        uniqueId: "ID",                     //每一行的唯一标识，一般为主键列
        showToggle: false,                    //是否显示详细视图和列表视图的切换按钮
        cardView: false,                    //是否显示详细视图
        detailView: false,
        //rowStyle:rowStyle,//通过自定义函数设置行样式
        ajaxOptions: {
            headers: {
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + localStorage.getItem("token")
            }
        },
        columns: [
            {
                title: '操作',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    row = JSON.stringify(row);
                    var str = '<button type="button" class="btn btn-primary  btn-sm" onclick=editUser(' + row + ')>设置角色</button>';
                    return [str].join('');
                }
            },
            {
                field: 'userIdCode',
                title: '员工编号',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return row.user.userIdCode;
                }
            },
            {
                field: 'userCode',
                title: '工号',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return row.user.userCode;
                }
            }, {
                field: 'userName',
                title: '姓名',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return row.user.userName;
                }
            }, {
                field: 'roleName',
                title: '角色',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return row.roleName;
                }
            }, {
                field: 'createTime',
                title: '更新时间',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return value == null ? "-" : format(value, "yyyy-MM-dd HH:mm:ss");
                }
            }, {
                field: 'createName',
                title: '更新人',
                align: "center",
                valign: 'middle'
            }
        ],
        responseHandler: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var ress = eval(res);
            if (ress.code == -1) {
                if (ress.message != null && ress.message != '') {
                    new PNotify({
                        title: '错误提示',
                        text: ress.message,
                        type: 'error',
                        hide: true,
                        styling: 'bootstrap3'
                    });
                }
                return {
                    "total": 0,//总页数
                    "rows": {}   //数据
                };
            }
            return {
                "total": ress.total,//总页数
                "rows": ress.data   //数据
            };
        },
    });
}

/**
 * 构建列表查询参数
 * @param params
 * @returns {{mzChargeDetail: {patientId: string | number | string[] | undefined | jQuery, warnDept: string | number | string[] | undefined | jQuery, doctorCode: string | number | string[] | undefined | jQuery, name: string | number | string[] | undefined | jQuery, payMark: number}, beginTime: Date, endTime: Date, pageSize: *, pageIndex: number}}
 */
function queryParams(params) {
    var temp = {
        pageSize: params.limit,
        offset: params.offset,
        userCode: $("#userCodeSearch").val() == "" ? null : $("#userCodeSearch").val(),
        userName: $("#userNameSearch").val() == "" ? null : $("#userNameSearch").val()
    };
    return temp;
};


/**
 * 打开编辑窗口
 * @param row
 */
function editUser(row) {
    clearInput();
    $("#classTitle").text("修改");
    $("#id").val(row.user.id);
    $("#userName").val(row.user.userName);
    $("#userCode").val(row.user.userCode);
    row.roleIds != null ? $("#roleName").val(row.roleIds.split(",")) : $("#roleName").val("");
    $("#roleName").selectpicker('refresh');
    $("#editModal").modal();
}

/**
 * 重置查询表单
 */
function resetSearch() {
    $("#userCodeSearch").val(null);
    $("#userNameSearch").val(null);
}
